#ifndef APPLIABLETRANSRANSMODULE__H
#define APPLIABLETRANSRANSMODULE__H

#include <torch/torch.h>
#include "Submodule.hpp"
#include "MyModule.hpp"
#include "LSTM.hpp"
#include "GRU.hpp"

class AppliableTransModuleImpl : public Submodule
{
  private :

  int nbTrans;

  public :

  AppliableTransModuleImpl(std::string name, int nbTrans);
  torch::Tensor forward(torch::Tensor input);
  std::size_t getOutputSize() override;
  std::size_t getInputSize() override;
  void addToContext(std::vector<std::vector<long>> & context, const Config & config) override;
  void registerEmbeddings() override;
};
TORCH_MODULE(AppliableTransModule);

#endif

